
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>深入理解JavaScript系列(11) 执行上下文（Execution Contexts）_javascript技巧 / iVAN</title>

    <meta name="description" content="深入理解JavaScript系列(11) 执行上下文（Execution Contexts）_javascript技巧 简介 从本章开始,我将陆续(翻译.转载.整理)http://dmitrysoshnikov.com/网站关于ECMAScript标标准理解的好文. 本章我们要讲解的是ECMAScript标准里的执行上下文和相关可执行代码的各种类型. 原始作者:Dmitry A. Soshnikov 原始发布: 2009-06-26 俄文原文:http://dmitrysoshnikov.com/ecmascript/ru-chapter-1-execution-contexts/ 英文翻译:Dmitry A.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">深入理解JavaScript系列(11) 执行上下文（Execution Contexts）_javascript技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>简介 <br />从本章开始，我将陆续（翻译、转载、整理）http://dmitrysoshnikov.com/网站关于ECMAScript标标准理解的好文。</p>
<p>本章我们要讲解的是ECMAScript标准里的执行上下文和相关可执行代码的各种类型。</p>
<p>原始作者：Dmitry A. Soshnikov <br />原始发布: 2009-06-26 <br />俄文原文：http://dmitrysoshnikov.com/ecmascript/ru-chapter-1-execution-contexts/</p>
<p>英文翻译：Dmitry A. Soshnikov. <br />发布时间：2010-03-11 <br />英文翻译：http://dmitrysoshnikov.com/ecmascript/chapter-1-execution-contexts/</p>
<p>本文参考了博客园justinw的中文翻译，做了一些错误修正，感谢译者。 <br />复制代码 <br />定义 <br />每次当控制器转到ECMAScript可执行代码的时候，即会进入到一个执行上下文。执行上下文(简称-EC)是ECMA-262标准里的一个抽象概念，用于同可执行代码(executable code)概念进行区分。</p>
<p>标准规范没有从技术实现的角度定义EC的准确类型和结构，这应该是具体实现ECMAScript引擎时要考虑的问题。</p>
<p>活动的执行上下文组在逻辑上组成一个堆栈。堆栈底部永远都是全局上下文(global context)，而顶部就是当前(活动的)执行上下文。堆栈在EC类型进入和退出上下文的时候被修改（推入或弹出）。</p>
<p>可执行代码类型 <br />可执行代码的类型这个概念与执行上下文的抽象概念是有关系的。在某些时刻，可执行代码与执行上下文完全有可能是等价的。</p>
<p>例如，我们可以定义执行上下文堆栈是一个数组：</p>
<p>ECStack = []; <br />每次进入function (即使function被递归调用或作为构造函数) 的时候或者内置的eval函数工作的时候，这个堆栈都会被压入。</p>
<p>全局代码 <br />这种类型的代码是在"程序"级处理的：例如加载外部的js文件或者本地&lt;script&gt;&lt;/script&gt;标签内的代码。全局代码不包括任何function体内的代码。</p>
<p>在初始化（程序启动）阶段，ECStack是这样的：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>ECStack = [ <br />globalContext <br />];</p>
<p>函数代码 <br />当进入funtion函数代码(所有类型的funtions)的时候，ECStack被压入新元素。需要注意的是，具体的函数代码不包括内部函数(inner functions)代码。如下所示，我们使函数自己调自己的方式递归一次：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>(function foo(bar) { <br />if (bar) { <br />return; <br />} <br />foo(true); <br />})();</p>
<p>那么，ECStack以如下方式被改变：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>// 第一次foo的激活调用 <br />ECStack = [ <br />&lt;foo&gt; functionContext <br />globalContext <br />];</p>
<p>// foo的递归激活调用 <br />ECStack = [ <br />&lt;foo&gt; functionContext – recursively <br />&lt;foo&gt; functionContext <br />globalContext <br />];</p>
<p>每次return的时候，都会退出当前执行上下文的，相应地ECStack就会弹出，栈指针会自动移动位置，这是一个典型的堆栈实现方式。一个抛出的异常如果没被截获的话也有可能从一个或多个执行上下文退出。相关代码执行完以后，ECStack只会包含全局上下文(global context)，一直到整个应用程序结束。</p>
<p>Eval 代码 <br />eval 代码有点儿意思。它有一个概念： 调用上下文(calling context),例如，eval函数调用的时候产生的上下文。eval(变量或函数声明)活动会影响调用上下文(calling context)。</p>
<p><u>复制代码</u> 代码如下:</p>
<p>eval('var x = 10');</p>
<p>(function foo() { <br />eval('var y = 20'); <br />})();</p>
<p>alert(x); // 10 <br />alert(y); // "y" 提示没有声明</p>
<p>ECStack的变化过程：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>ECStack = [ <br />globalContext <br />];</p>
<p>// eval('var x = 10'); <br />ECStack.push( <br />evalContext, <br />callingContext: globalContext <br />);</p>
<p>// eval exited context <br />ECStack.pop();</p>
<p>// foo funciton call <br />ECStack.push(&lt;foo&gt; functionContext);</p>
<p>// eval('var y = 20'); <br />ECStack.push( <br />evalContext, <br />callingContext: &lt;foo&gt; functionContext <br />);</p>
<p>// return from eval <br />ECStack.pop();</p>
<p>// return from foo <br />ECStack.pop();</p>
<p>也就是一个非常普通的逻辑调用堆栈。</p>
<p>在版本号1.7以上的SpiderMonkey(内置于Firefox,Thunderbird)的实现中，可以把调用上下文作为第二个参数传递给eval。那么，如果这个上下文存在，就有可能影响“私有”(有人喜欢这样叫它)变量。</p>
<p><u>复制代码</u> 代码如下:</p>
<p>function foo() { <br />var x = 1; <br />return function () { alert(x); }; <br />};</p>
<p>var bar = foo();</p>
<p>bar(); // 1</p>
<p>eval('x = 2', bar); // 传入上下文，影响了内部的var x 变量</p>
<p>bar(); // 2</p>
<p>结论 <br />这篇文章是后面分析其他跟执行上下文相关的主题(例如变量对象，作用域链，等等)的最起码的理论基础，这些主题将在后续章节中讲到。</p>
<p>其他参考</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 16:24:29</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/execution/" title="Execution">Execution</a>, <a href="https://www.iamivan.net/tag/contexts/" title="Contexts">Contexts</a>, <a href="https://www.iamivan.net/tag/%e6%89%a7%e8%a1%8c%e4%b8%8a%e4%b8%8b%e6%96%87/" title="执行上下文">执行上下文</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>深入理解JavaScript系列(11) 执行上下文（Execution Contexts）_javascript技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmG1vz.html" rel="bookmark">深入理解JavaScript系列&lpar;2&rpar; 揭秘命名函数表达式&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 网上还没用发现有人对命名函数表达式进去重复深入的讨论,正因为如此,网上出现了各种各样的误解,本文将从原理和实践两个方面来探讨JavaScript关于命名函数表达式的优缺点. 简单的说,命名函数表达式只有一个用户,那就是在Debug或者Profiler分析的时候来描述函数的名称,也可以使用函数名实现递归,但很快你就会发现其实是不切实际的.当然,如果你不关注调试,那就没什么可担心的了,否则,如果你想了解兼容性方面的东西的话,你还是应该继续往下看看. 我们先开始看看,什么叫函数表达式,然后再说一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQXaap.html" rel="bookmark">深入理解JavaScript系列&lpar;3&rpar; 全面解析Module模式&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 Module模式是JavaScript编程中一个非常通用的模式,一般情况下,大家都知道基本用法,本文尝试着给大家更多该模式的高级使用方式. 首先我们来看看Module模式的基本特征: 模块化,可重用 封装了变量和function,和全局的namaspace不接触,松耦合 只暴露可用public的方法,其它私有方法全部隐藏 关于Module模式,最早是由YUI的成员Eric Miraglia在4年前提出了这个概念,我们将从一个简单的例子来解释一下基本的用法(如果你已经非常熟悉了,请忽略这一节			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRdPOBz.html" rel="bookmark">javascript系列之执行上下文</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:javascript系列之执行上下文       写在前面:一 直想系统的总结一下学过的javascript知识,喜欢这门语言也热爱这门语言.未来想从事前端方面的工作,提前把自己的知识梳理一下.前面写了些 DOM的知识,略觉水平有限.没几个月就要开赴找工作的前线,奈何自己还是个菜鸟,具体写的时候还没有一个完整的思路.多番考虑之后,决定还是翻译外国的 经典系列文章,总结提升的同时,英语水平也可以上一个台阶,双管齐下,相信对以后肯定有好处.当然这个系列的文章已经有好多人翻译过了,水平都挺高(我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8NLYVb.html" rel="bookmark">浅析JavaScript作用域链、执行上下文与闭包&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				闭包和作用域链是JavaScript中比较重要的概念,这两天翻阅了一些资料,把相关知识点给大家总结了以下. JavaScript 采用词法作用域(lexical scoping),函数执行依赖的变量作用域是由函数定义的时候决定,而不是函数执行的时候决定.以下面的代码片段举例说明,通常来说(基于栈的实现,如 C 语言) foo 被调用之后函数内的本地变量 scope 会被释放,但是从词法上看 foo 的内嵌匿名函数中 scope 应该指的是 foo 的本地变量 scope ,并且实际上代码的运行结			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5QLgmp.html" rel="bookmark">深入理解JavaScript中为什么string可以拥有方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引子 我们都知道,JavaScript数据类型分两大类,基本类型(或者称原始类型)和引用类型. 基本类型的值是保存在栈内存中的简单数据段,它们是按值访问的.JS中有五种基本类型:Undefined.Null.Boolean.Number和String. 引用类型的值是保存在堆内存中的对象,它的值是按引用访问的.引用类型主要有Object.Array.Function.RegExp.Date. 对象是拥有属性和方法的,所以我们看到下面这段代码一点也不奇怪. var favs=['鸡蛋','莲蓬']			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zemEN8z.html" rel="bookmark">this和执行上下文实现代码&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				函数的执行上下文由当前的运行环境而定: 1. 全局变量和全局函数附属于全局对象(window),因此使用&quot;var&quot;或&quot;this&quot;两种方法定义全局变量是等效的. 2. 执行上下文和作用域不同.执行上下文在运行时确定,随时可能改变,而作用域则在定义时确定,永远不会变. 3. 如果当前执行的是一个对象的方法,则执行上下文就是这个方法所附属的对象. 4. 如果当前是一个创建对象的过程或者执行一个对象的方法,则执行上下文就是这个正在被创建的对象. 5. 如果一个方法在执行时没			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boR2WBz.html" rel="bookmark">javascript中强制执行toString&lpar;&rpar;具体实现&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Enforcing toString() 译文:javascript 中强制执行 toString() 译者:singleseeker Javascript通常会根据方法或运算符的需要而自动把值转成所需的类型,这可能导致各种错误. Brian McKenna (@puffnfresh) suggests 提供了下列测试代码: 复制代码 代码如下: Object.prototype.valueOf = function () { throw new Error('Use an explici			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boLjAEM.html" rel="bookmark">关于Javascript加载执行优化的研究报告&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本人做前端开发一年多了,对前端的见解还是多多少少有一点的,今天特拿出来跟大家分享分享. 做前端开发少不了各种利器.比如我习惯用的还是Google浏览器和重型武器Fiddller. 一: 原始情况 首先大家看看如下的代码: 复制代码 代码如下: &lt;%@ Page Language=&quot;C#&quot; AutoEventWireup=&quot;true&quot; CodeBehind=&quot;Default.aspx.cs&quot; Inherits=&quot;JsLoad.Def			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnna40p.html" rel="bookmark">理解Javascript的caller&comma;callee&comma;call&comma;apply区别&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在提到上述的概念之前,首先想说说javascript中函数的隐含参数:arguments arguments 该对象代表正在执行的函数和调用它的函数的参数. [function.]arguments[n] 参数function :选项.当前正在执行的 Function 对象的名字. n :选项.要传递给 Function 对象的从0开始的参数值索引.  说明 arguments是进行函数调用时,除了指定的参数外,还另外创建的一个隐藏对象.arguments是一个类似数组但不是数组的对象,说它类似			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgw2OM.html" rel="bookmark" class="title">photoshop动作的录制及使用教程</a>
					<div>
						动作的应用可以说让本就神奇的photoshop更加如虎添翼,有了动作可以让很多的操作模块化.函数化,而且大家通过录制动作可以将很多操作传递给别人使用,非常的方便,所以掌握动作的录制及使用也是一种必备的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPlQ1p.html" rel="bookmark" class="title">ARM架构</a>
					<div>
						ARM架构(过去称作进阶精简指令集机器(Advanced RISC Machine),更早称作Acorn RISC Machine)是一个32位元精简指令集(RISC) 中央处理器(processor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnPD0b.html" rel="bookmark" class="title">select 一定要注意 text</a>
					<div>
						select SELECT * FROM DT_FUNCTION_POINT WHERE NODE_CODE = '123'; 写成这样,比较正式,而且自己也清楚.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zey9xz.html" rel="bookmark" class="title">flash as3&period;0粒子效果实例教程</a>
					<div>
						1.新建Flash文档,设置:宽.高为 400 × 400 ,保存. 2.用椭圆工具在舞台上画一个 20 × 20 大小的圆. (你能选择任意的颜色) 3.右键单击圆形,把它转换成影片剪辑,注册点居中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M01ODp.html" rel="bookmark" class="title">ASP&period;NET Server Control Design Time Support</a>
					<div>
						asp.net|server ASP.NET Server Control Design Time Support 做过自己的 asp.net server control 了吗?有没有象 ASP.N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKDndM.html" rel="bookmark" class="title">ajax框架之dojo篇（一）</a>
					<div>
						一.do对象的函数 1) dojo.byId(id) &lt;input type=&quot;text&quot; id=&quot;txtId&quot; size=&quot;30&quot;& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1Krjz.html" rel="bookmark" class="title">OpenGL编程轻松入门之堆栈操作</a>
					<div>
						本节中的例子其结构和例1一样,仅改变myDisplay和myReshape. 例4:利用堆栈绘制三个物体--一个绿色的茶壶,一个蓝色的茶壶,一个红色的立方体(部分代码) void myDisplay( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLV7Yb.html" rel="bookmark" class="title">MySQL双向复制技术详解</a>
					<div>
						设置MySQL数据同步(单向&amp;双向)由于公司的业务需求,需要网通和电信的数据同步,就做了个MySQL的双向同步,记下过程,以后用得到再翻出来,也贴出来供大家参考. 一.准备服务器 由于MySQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNdNvb.html" rel="bookmark" class="title">jquery的ajaxSubmit&lpar;&rpar;异步上传图片并保存表单数据演示代码</a>
					<div>
						 一:web (add.jsp)   代码如下: &lt;%@page import=&quot;com.fingerknow.project.vo.UserInformation&quot;%&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3o9eJb.html" rel="bookmark" class="title">Win7预览网页鼠标右键菜单卡住无响应怎么办</a>
					<div>
						  我们可能都会遇到在win7旗舰版系统下载安装的系统中,在使用浏览器上网浏览一些网页的时候常常都会遇到鼠标的右键,因为这里面的菜单还是非常常用的,比如说复制粘贴,或者是另存为这些都是非常常用的,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badjj2z.html" rel="bookmark" class="title">Js从头学起（基本数据类型和引用类型的参数传递详细分析）&lowbar;基础知识</a>
					<div>
						1.基本数据类型传递参数: 复制代码 代码如下: funciton addTen(num){ num+=10; return num; } var count=20; var result=addTe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkwa7b.html" rel="bookmark" class="title">webapp-在命令提示符下使用MAVEN创建项目失败</a>
					<div>
						问题描述 在命令提示符下使用MAVEN创建项目失败 使用maven3.3.1,输入如下命令建立web项目时出错 mvn archetype:create -DgroupId=oschina -Dart ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1ldV9b.html" rel="bookmark" class="title">我的2011&mdash;&mdash;我的第一个年终总结</a>
					<div>
						这一年于我发生了太多事情,却没有改变我太多的思想. 都说工作几年的人菱角会被慢慢磨平,这可不是我想要的,我想实实倾听我内心的声音,想要变得坚强,能处理好更多的事情,但不想改变自己最初的想法.每当因为一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8k75VM.html" rel="bookmark" class="title">数字生活小技巧 - 5个小妙招轻松管理你的电子文档</a>
					<div>
						class=&quot;post_content&quot; itemprop=&quot;articleBody&quot;&gt; 现在我们每天的生活就是抱着电脑,有台式有手提有平板.互联网就是我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRq2GKb.html" rel="bookmark" class="title">基于嵌入式操作系统VxWorks的多任务并发程序设计（1）&horbar;&horbar;基本概念</a>
					<div>
						1引言 嵌入式系统定义义为:嵌入到对象体系中的专用计算机系统.&quot;嵌入性&quot;.&quot;专用性&quot;与&quot;计算机系统&quot;是嵌入式统的三个基本要素,对象系统则是指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7glWp.html" rel="bookmark" class="title">java方法块-java当中trim方法是干什么用的</a>
					<div>
						问题描述 java当中trim方法是干什么用的 java当中trim方法是干什么用的 好像记得是数组对象才可以调用此方法是吧 解决方案 你说的是String类中的方法trim,这个trim用来去除字符 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAr6eM.html" rel="bookmark" class="title">opencv 单目摄像头测距问题</a>
					<div>
						问题描述 opencv 单目摄像头测距问题 各位大神好,我是opencv新手,现在在做一个项目,要求用单目摄像头提取图像中的深度信息,测量之前已经识别出来的障碍物与摄像头的距离. 现在已经在网上找到标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAkAqp.html" rel="bookmark" class="title">myeclipse装aptana插件后java源文件中文乱码</a>
					<div>
						问题描述 myeclipse装aptana插件后java源文件中文乱码 刚装了aptana插件,原本用utf-8编码的java文件中的中文乱码,然后我看了下编辑的编码没变,文件的编码方式没变,但就是中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Z0EAM.html" rel="bookmark" class="title">c&plus;&plus;-跪求大神帮忙写出程序啊～。</a>
					<div>
						问题描述 跪求大神帮忙写出程序啊-. 大神??啊??朋友给我个题?我真作难了??是这样?: 有29组数字??,选任意8组为一组? 要求 1.?求这8组中共有的数字 ?2.要除掉 12345678 23 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZg4dab.html" rel="bookmark" class="title">ios视频的合成 剪切 和视频合成过渡效果</a>
					<div>
						问题描述 ios视频的合成 剪切 和视频合成过渡效果 关于ios视频的合成 剪切 过渡效果 我在网上搜勒2天 资料真的很少 希望哪位会的 帮我解决一下 谢谢 解决方案 ios视频和音频的合成视频合成, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJADKDp.html" rel="bookmark" class="title">swfupload选择按钮图片显示问题，小弟在线等</a>
					<div>
						问题描述 swfupload选择按钮赋值代码:button_image_url:&quot;/statics/js/swfupload/images/swfBnt_select.png&quot;,b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Rw9mz.html" rel="bookmark" class="title">android 调用系统相册裁剪无效</a>
					<div>
						问题描述 android 调用系统相册裁剪无效 这是调用,打开图片后没有跳到裁剪.但如果选取图片时从图片浏览应用比如快图就可以正常裁剪并返回 为什么呢? 解决方案 Android 调用系统相册(带裁剪 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR2X1b.html" rel="bookmark" class="title">用友UAP&colon;信息安全从自主可控的信息系统做起</a>
					<div>
						用友公司董事长王文京在2014年两会的建议案中指出,国家应尽快出台世界各国通行的信息安全审查制度;积极实施国家和国计民生重要信息系统的国产化替代策略,增强产业自主可控能力.用友UAP认为,国家加强信息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnKLKM.html" rel="bookmark" class="title">c&num;转换日期格式问题</a>
					<div>
						问题描述 SqlConnectiondate1=newSqlConnection(str);date1.Open();stringx=DropDownList3.SelectedValue+&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodlXVM.html" rel="bookmark" class="title">浅谈TCP优化</a>
					<div>
						原文地址:http://kb.cnblogs.com/page/197406/ 很多人常常对TCP优化有一种雾里看花的感觉,实际上只要理解了TCP的运行方式就能掀开它的神秘面纱.Ilya Grigor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlL40nM.html" rel="bookmark" class="title">《MATLAB图像处理375例》&mdash;&mdash;1&period;3 MATLAB概述</a>
					<div>
						1.3 MATLAB概述 MATLAB图像处理375例 MATLAB名字由MATrix和LABoratory两词的前三个字母组合而成.MATLAB以商品形式出现后的短短几年,就以其良好的开放性和运行的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgN9AM.html" rel="bookmark" class="title">如何使你的博客大受欢迎？</a>
					<div>
						如果自己的博客现在还不受欢迎,先不要质疑读者的欣赏水平,也不要低估读者对知识的渴求,因为最简单.最可能的原因是:博文的质量还不够好.这是一篇讨论如何提高博文质量的博文. 去年9月的时候阅读了所有能找得 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8Q7mp.html" rel="bookmark" class="title">【手机观察】小米4联通版获入网许可 10色可选</a>
					<div>
						最近关于小米4的话题可谓不断,同时距离7月29日正式上市的日子越来越近,今天早上Book中文资讯网小编浏览工信部网站的时候意外发现小米4除了本身黑.白两种颜色外,竟然还有其它8款颜色供用户选择,分别为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmBKXz.html" rel="bookmark" class="title">linux服务器&lpar;nginx或者apache&rpar;限制IP访问的方法</a>
					<div>
						近段时间一直饱受垃圾评论的攻击,服务器一度负载太高而宕机,参见:WordPress垃圾评论防御记.开始试了很多方法都不能很好的解决问题,最后通过屏蔽垃圾评论IP的方式,算是解决了这个问题,当然这个方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqNPEp.html" rel="bookmark" class="title">java-Java怎么实现界面？类似普通程序的界面？swing 到底学不学？</a>
					<div>
						问题描述 Java怎么实现界面?类似普通程序的界面?swing 到底学不学? Java怎么实现界面的.?swing不是可以么?为什么有人说不让我学?那我应该学什么? 解决方案 AWT和Swing吧,但 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
